package client

import (
	"net"
	"time"

	"git.loafle.net/commons_go/rpc"
	"git.loafle.net/commons_go/rpc/protocol"
)

type ClientHandler interface {
	Connect() (net.Conn, error)
	GetCodec() protocol.ClientCodec

	GetRPCRegistry() rpc.Registry
	GetRequestTimeout() time.Duration
	GetPendingRequests() int

	GetRequestID() interface{}
	Validate()
}
